{ Oplossing van de opgave 'Palindromie'
  Joris van Rantwijk, Jan 2001
  Algoritme: dynamisch programmeren }

program Palindr;

var
  mins: array[1..200, 0..200] of Byte;
  { mins[i,k] is het minimaal aantal letters dat moet worden overgeslagen
    om van het subwoord beginnend op letter i en met lengte k, een palindroom
    te maken. Het kan ook met 200 bytes geheugen maar dat is lastiger. }

function MinSkip(const w: String): Integer;
var
  i, k, m: Integer;
begin
  { alle woorden van lengte 0 en 1 zijn palindromen }
  for i := 1 to Length(w) do begin
    mins[i][0] := 0;
    mins[i][1] := 0;
  end; {for}

  for k := 2 to Length(w) do begin
    { beschouw alle substrings van lengte k }
    for i := 1 to Length(w) - k + 1 do begin
      { Een substring van lengte k kun je maken door aan een substring
        van lengte k-1 een letter toe te voegen, links of rechts. Het
        aantal letters dat moet worden overgeslagen wordt dan ook 1 meer. }
      m := mins[i][k-1];
      if mins[i+1][k-1] < m then m := mins[i+1][k-1];
      m := m + 1;
      { Je kunt ook een substring van lengte k maken door aan een substring
        van lengte k-2 links en rechts dezelfde letter toe te voegen. Het
        aantal letters dat moet worden overgeslagen blijft dan gelijk. }
      if (mins[i+1][k-2] < m) and (w[i] = w[i+k-1]) then m := mins[i+1][k-2];
      mins[i][k] := m;
    end; {for}
  end; {for}

  MinSkip := mins[1][Length(w)];
end; {MinSkip}

var
  n, i: Integer;
  w: String;

begin

  ReadLn(n);

  for i := 1 to n do begin
    ReadLn(w);
    WriteLn(MinSkip(w));
  end; {for}

end. {Palindr}
